(* Title:  Test_Z_Transform
   Author: Jan Rocnik
   (c) copyright due to lincense terms.
12345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50        60        70        80
*)

theory Inverse_Z_Transform imports Isac begin

section {*trials towards Z transform *}
text{*===============================*}
subsection {*terms*}
ML {*
@{term "1 < || z ||"};
@{term "z / (z - 1)"};
@{term "-u -n - 1"};
@{term "-u [-n - 1]"}; (*[ ] denotes lists !!!*)
@{term "z /(z - 1) = -u [-n - 1]"};Isac
@{term "1 < || z || ==> z / (z - 1) = -u [-n - 1]"};
term2str @{term "1 < || z || ==> z / (z - 1) = -u [-n - 1]"};
*}
ML {*
(*alpha -->  "</alpha>" *)

@{term "\<alpha> "};
@{term "\<delta> "};
@{term "\<phi> "};
@{term "\<rho> "};
term2str @{term "\<rho> "};
*}

subsection {*rules*}
(*axiomatization "z / (z - 1) = -u [-n - 1]" Illegal variable name: "z / (z - 1) = -u [-n - 1]" *)
(*definition     "z / (z - 1) = -u [-n - 1]" Bad head of lhs: existing constant "op /"*)
axiomatization where 
  rule1: "1 = \<delta>[n]" and
  rule2: "|| z || > 1 ==> z / (z - 1) = u [n]" and
  rule3: "|| z || < 1 ==> z / (z - 1) = -u [-n - 1]" and 
  rule4: "|| z || > || \<alpha> || ==> z / (z - \<alpha>) = \<alpha>^n * u [n]" and
  rule5: "|| z || < || \<alpha> || ==> z / (z - \<alpha>) = -(\<alpha>^n) * u [-n - 1]" and
  rule6: "|| z || > 1 ==> z/(z - 1)^2 = n * u [n]"
ML {*
@{thm rule1};
@{thm rule2};
@{thm rule3};
@{thm rule4};
*}

subsection {*apply rules*}
ML {*
val inverse_Z = append_rls "inverse_Z" e_rls
  [ Thm  ("rule3",num_str @{thm rule3}),
    Thm  ("rule4",num_str @{thm rule4}),
    Thm  ("rule1",num_str @{thm rule1})   
  ];

val t = str2term "z / (z - 1) + z / (z - \<alpha>) + 1";
val SOME (t', asm) = rewrite_set_ thy true inverse_Z t;
term2str t' = "z / (z - ?\<delta> [?n]) + z / (z - \<alpha>) + ?\<delta> [?n]"; (*attention rule1 !!!*)
*}
ML {*
val (thy, ro, er) = (@{theory}, tless_true, eval_rls);
*}
ML {*
val SOME (t, asm1) = rewrite_ thy ro er true (num_str @{thm rule3}) t;
term2str t = "- ?u [- ?n - 1] + z / (z - \<alpha>) + 1"; (*- real *)
term2str t;
*}
ML {*
val SOME (t, asm2) = rewrite_ thy ro er true (num_str @{thm rule4}) t;
term2str t = "- ?u [- ?n - 1] + \<alpha> ^ ?n * ?u [?n] + 1"; (*- real *)
term2str t;
*}
ML {*
val SOME (t, asm3) = rewrite_ thy ro er true (num_str @{thm rule1}) t;
term2str t = "- ?u [- ?n - 1] + \<alpha> ^ ?n * ?u [?n] + ?\<delta> [?n]"; (*- real *)
term2str t;
*}
ML {*
terms2str (asm1 @ asm2 @ asm3);
*}

section {*Prepare steps in CTP-based programming language*}
text{*===================================================*}
subsection {*prepare expression*}
ML {*
val ctxt = ProofContext.init_global @{theory};
val ctxt = declare_constraints' [@{term "z::real"}] ctxt;

val SOME fun1 = parseNEW ctxt "X z = 3 / (z - 1/4 + -1/8 * z ^ -1)"; term2str fun1;
val SOME fun1' = parseNEW ctxt "X z = 3 / (z - 1/4 + -1/8 * (1/z))"; term2str fun1';
*}

axiomatization where
  ruleZY: "(X z = a / b) = (X' z = a / (z * b))"

ML {*
val (thy, ro, er) = (@{theory}, tless_true, eval_rls);
val SOME (fun2, asm1) = rewrite_ thy ro er true  @{thm ruleZY} fun1; term2str fun2;
val SOME (fun2', asm1) = rewrite_ thy ro er true  @{thm ruleZY} fun1'; term2str fun2';

val SOME (fun3,_) = rewrite_set_ @{theory Isac} false norm_Rational fun2;
term2str fun3; (*fails on x^(-1) TODO*)
val SOME (fun3',_) = rewrite_set_ @{theory Isac} false norm_Rational fun2';
term2str fun3'; (*OK*)

val (_, expr) = HOLogic.dest_eq fun3'; term2str expr;
*}

subsection {*solve equation*}
ML {*(*from test/Tools/isac/Minisubpbl/100-init-rootpbl.sml*)
"----------- Minisubplb/100-init-rootp (*OK*)bl.sml ---------------------";
val denominator = parseNEW ctxt "z^2 - 1/4*z - 1/8 = 0";
val fmz = ["equality (z^2 - 1/4*z - 1/8 = (0::real))", "solveFor z","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);
(*                           ^^^^^^^^^^^^^^^^^^^^^^ TODO: ISAC determines type of eq*)
*}
ML {*
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[
(([], Frm), solve (z ^ 2 - 1 / 4 * z - 1 / 8 = 0, z)),
(([1], Frm), z ^ 2 - 1 / 4 * z - 1 / 8 = 0),              bad rewrite order
(([1], Res), -1 / 8 + z ^ 2 + -1 / 4 * z = 0),            bad pattern
(([2], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1,1], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1,1,1], Frm), -1 / 8 + z ^ 2 + -1 / 4 * z = 0)] 
*)
*}
ML {*
val denominator = parseNEW ctxt "-1/8 + -1/4*z + z^2 = 0";
(*ergebnis: [gleichung, was tun?, lösung]*)
val fmz = ["equality (-1/8 + -1/4*z + z^2 = (0::real))", "solveFor z","solutions L"];
(*liste der theoreme die zum lösen benötigt werden, aus isac, keine spezielle methode (no met)*)
val (dI',pI',mI') =
  ("Isac", ["pqFormula","degree_2","polynomial","univariate","equation"], ["no_met"]);
(*schritte abarbeiten*)
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*val nxt = ("Empty_Tac", ...): tac'_*)
show_pt pt;
*}

subsection {*partial fraction decomposition*}
subsubsection {*solution of the equation*}
ML {*
val SOME solutions = parseNEW ctxt "[z=1/2, z=-1/4]";
term2str solutions;
atomty solutions;
*}

subsubsection {*get solutions out of list*}
text {*in isac's CTP-based programming language: $let s_1 = NTH 1 solutions; s_2 = NTH 2...$*}
ML {*
val Const ("List.list.Cons", _) $ s_1 $ (Const ("List.list.Cons", _) $
      s_2 $ Const ("List.list.Nil", _)) = solutions;
term2str s_1;
term2str s_2;
*}

ML {* (*Solutions as Denominator --> Denominator1 = z - Zeropoint1, Denominator2 = z-Zeropoint2,...*)
val xx = HOLogic.dest_eq s_1;
val s_1' = HOLogic.mk_binop "Groups.minus_class.minus" xx;
val xx = HOLogic.dest_eq s_2;
val s_2' = HOLogic.mk_binop "Groups.minus_class.minus" xx;
term2str s_1';
term2str s_2';
*}

subsubsection {*build expression*}
text {*in isac's CTP-based programming language: $let s_1 = Take numerator / (s_1 * s_2)$*}
ML {*
(*The Main Denominator is the multiplikation of the partial fraction denominators*)
val denominator' = HOLogic.mk_binop "Groups.times_class.times" (s_1', s_2') ;
val SOME numerator = parseNEW ctxt "3::real";

val expr' = HOLogic.mk_binop "Rings.inverse_class.divide" (numerator, denominator');
term2str expr';
*}

subsubsection {*Ansatz - create partial fractions out of our expression*}

axiomatization where
  ansatz2: "n / (a*b) = A/a + B/(b::real)" and
  multiply_eq2: "(n / (a*b) = A/a + B/b) = (a*b*(n  / (a*b)) = a*b*(A/a + B/b))"

ML {*
(*we use our ansatz2 to rewrite our expression and get an equilation with our expression on the left and the partial fractions of it on the right side*)
val SOME (t1,_) = rewrite_ @{theory Isac} e_rew_ord e_rls false @{thm ansatz2} expr';
term2str t1;
atomty t1;
val eq1 = HOLogic.mk_eq (expr', t1);
term2str eq1;
*}
ML {*
(*eliminate the demoninators by multiplying the left and the right side with the main denominator*)
val SOME (eq2,_) = rewrite_ @{theory Isac} e_rew_ord e_rls false @{thm multiply_eq2} eq1;
term2str eq2;
*}
ML {*
(*simplificatoin*)
val SOME (eq3,_) = rewrite_set_ @{theory Isac} false norm_Rational eq2;
term2str eq3; (*?A ?B not simplified*)
*}
ML {*
val SOME fract1 =
  parseNEW ctxt "(z - 1 / 2) * (z - -1 / 4) * (A / (z - 1 / 2) + B / (z - -1 / 4))"; (*A B !*)
val SOME (fract2,_) = rewrite_set_ @{theory Isac} false norm_Rational fract1;
term2str fract2 = "(A + -2 * B + 4 * A * z + 4 * B * z) / 4";
(*term2str fract2 = "A * (1 / 4 + z) + B * (-1 / 2 + z)" would be more traditional*)
*}
ML {*
val (numerator, denominator) = HOLogic.dest_eq eq3;
val eq3' = HOLogic.mk_eq (numerator, fract1); (*A B !*)
term2str eq3';
*}
ML {* (*MANDATORY: otherwise 3 = 0*)
val SOME (eq3'' ,_) = rewrite_set_ @{theory Isac} false norm_Rational eq3';
term2str eq3'';
*}

subsubsection {*get first koeffizient*}

ML {*
(*substitude z with the first zeropoint to get A*)
val SOME (eq4_1,_) = rewrite_terms_ @{theory Isac} e_rew_ord e_rls [s_1] eq3'';
term2str eq4_1;
*}
ML {*
val SOME (eq4_2,_) = rewrite_set_ @{theory Isac} false norm_Rational eq4_1;
term2str eq4_2;
*}
ML {*
val fmz = ["equality (3 = 3 * A / (4::real))", "solveFor A","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);

*}
ML {*
(*solve the simple linear equilation for A TODO: return eq, not list of eq*)
val (p,_,fa,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
val (p,_,fa,nxt,_,pt) = me nxt p [] pt;
*}
ML {*
val (p,_,fa,nxt,_,pt) = me nxt p [] pt; 
f2str fa;
*}

subsubsection {*get second koeffizient*}

ML {*
(*substitude z with the second zeropoint to get B*)
val SOME (eq4b_1,_) = rewrite_terms_ @{theory Isac} e_rew_ord e_rls [s_2] eq3'';
term2str eq4b_1;
*}

ML {*
val SOME (eq4b_2,_) = rewrite_set_ @{theory Isac} false norm_Rational eq4b_1;
term2str eq4b_2;
*}

ML {*
(*solve the simple linear equilation for B TODO: return eq, not list of eq*)
val fmz = ["equality (3 = -3 * B / (4::real))", "solveFor B","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);
val (p,_,fb,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; 
f2str fb;
*}

ML {* (*check koeffizients*)
if f2str fa = "[A = 4]" then () else error "part.fract. eq4_1";
if f2str fb = "[B = -4]" then () else error "part.fract. eq4_1";
*}

subsubsection {*substitute expression with solutions*}
ML {*
*}

section {*Implement the Specification and the Method*}
text{*==============================================*}
subsection{*Define the Specification*}
ML {*
val thy = @{theory};
*}
ML {*
store_pbt
 (prep_pbt thy "pbl_SP" [] e_pblID
 (["SignalProcessing"], [], e_rls, NONE, []));
store_pbt
 (prep_pbt thy "pbl_SP_Ztrans" [] e_pblID
 (["Z_Transform","SignalProcessing"], [], e_rls, NONE, []));
store_pbt
 (prep_pbt thy "pbl_SP_Ztrans_inv" [] e_pblID
 (["inverse", "Z_Transform", "SignalProcessing"],
  [("#Given" ,["equality X_eq"]),
   ("#Find"  ,["equality n_eq"])
  ],
  append_rls "e_rls" e_rls [(*for preds in where_*)], NONE, 
  [["TODO: path to method"]]));

show_ptyps();
get_pbt ["inverse","Z_Transform","SignalProcessing"];
*}

subsection{*Define the (Dummy-)Method*}
subsection {*Define Name and Signature for the Method*}
consts
  InverseZTransform :: "[bool, bool] => bool"
    ("((Script InverseZTransform (_ =))// (_))" 9)

ML {*
store_met
 (prep_met thy "met_SP" [] e_metID
 (["SignalProcessing"], [],
   {rew_ord'="tless_true", rls'= e_rls, calc = [], srls = e_rls, prls = e_rls,
    crls = e_rls, nrls = e_rls}, "empty_script"));
store_met
 (prep_met thy "met_SP_Ztrans" [] e_metID
 (["SignalProcessing", "Z_Transform"], [],
   {rew_ord'="tless_true", rls'= e_rls, calc = [], srls = e_rls, prls = e_rls,
    crls = e_rls, nrls = e_rls}, "empty_script"));
*}
ML {*
store_met
 (prep_met thy "met_SP_Ztrans_inv" [] e_metID
 (["SignalProcessing", "Z_Transform", "inverse"], [],
   {rew_ord'="tless_true", rls'= e_rls, calc = [], srls = e_rls, prls = e_rls,
    crls = e_rls, nrls = e_rls}, 
  "empty_script"
 ));
*}
ML {*(*
store_met
 (prep_met thy "met_SP_Ztrans_inv" [] e_metID
 (["SignalProcessing", "Z_Transform", "inverse"], [],
   {rew_ord'="tless_true", rls'= e_rls, calc = [], srls = e_rls, prls = e_rls,
    crls = e_rls, nrls = e_rls}, 
  "Script InverseZTransform (Xeq::bool) =" ^
  " (let X = Take Xeq;" ^
  "      X = Rewrite ruleZY False X" ^
  "  in X)"
 ));
*)*}
ML {*
show_mets();
get_met ["SignalProcessing","Z_Transform","inverse"];
*}


section {*Program in CTP-based language*}
text{*=================================*}
subsection {*Stepwise extend Program*}
ML {*
val str = 
"Script InverseZTransform (Xeq::bool) =" ^
" Xeq";
*}
ML {*
val str = 
"Script InverseZTransform (Xeq::bool) =" ^
" (let X = Take Xeq;" ^
"      X = Rewrite ruleZY False X" ^
"  in X)";
*}
ML {*
val thy = @{theory};
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
*}
ML {*
term2str sc;
atomty sc
*}

subsection {*Stepwise Execute the Program*}








section {*Write Tests for Crucial Details*}
text{*===================================*}
ML {*

*}

section {*Integrate Program into Knowledge*}
ML {*

*}

end

